﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/InterferenceManagementInfoPerChannel.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/interference_management_info_per_channel.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_INFO_PER_CHANNEL__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_INFO_PER_CHANNEL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'interference_management_channel'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_channel__struct.h"
// Member 'interference_management_zone_type'
#include "etsi_its_vam_ts_msgs/msg/detail/interference_management_zone_type__struct.h"
// Member 'interference_management_mitigation_type'
#include "etsi_its_vam_ts_msgs/msg/detail/mitigation_for_technologies__struct.h"
// Member 'expiry_time'
#include "etsi_its_vam_ts_msgs/msg/detail/timestamp_its__struct.h"

/// Struct defined in msg/InterferenceManagementInfoPerChannel in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// InterferenceManagementInfoPerChannel ::= SEQUENCE {
  ///     interferenceManagementChannel           InterferenceManagementChannel,
  ///     interferenceManagementZoneType          InterferenceManagementZoneType,
  ///     interferenceManagementMitigationType    MitigationForTechnologies OPTIONAL,
  ///     expiryTime                              TimestampIts OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF contains interference management information for one affected frequency channel.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field interferenceManagementChannel: frequency channel for which the zone should be applied interference management
  /// *
  /// * @field interferenceManagementZoneType: type of the interference management zone.
  /// *
  /// * @field interferenceManagementMitigationType: optional type of the mitigation to be used in the interference management zone.
  /// * In the case where no mitigation should be applied by the ITS-S, this is indicated by the field interferenceManagementMitigationType being absent.
  /// *
  /// * @field expiryTime: optional time at which the validity of the interference management communication zone will expire.
  /// * This component is present when the interference management is temporarily valid
  /// *
  /// * @category: Communication information
  /// * @revision: created in V2.1.1
  etsi_its_vam_ts_msgs__msg__InterferenceManagementChannel interference_management_channel;
  etsi_its_vam_ts_msgs__msg__InterferenceManagementZoneType interference_management_zone_type;
  etsi_its_vam_ts_msgs__msg__MitigationForTechnologies interference_management_mitigation_type;
  bool interference_management_mitigation_type_is_present;
  etsi_its_vam_ts_msgs__msg__TimestampIts expiry_time;
  bool expiry_time_is_present;
} etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel.
typedef struct etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel__Sequence
{
  etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__InterferenceManagementInfoPerChannel__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__INTERFERENCE_MANAGEMENT_INFO_PER_CHANNEL__STRUCT_H_
