﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/LongitudinalAccelerationValue.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/longitudinal_acceleration_value.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__LONGITUDINAL_ACCELERATION_VALUE__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__LONGITUDINAL_ACCELERATION_VALUE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__MIN = -160
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__MAX = 161
};

/// Constant 'NEGATIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__NEGATIVE_OUT_OF_RANGE = -160
};

/// Constant 'POSITIVE_OUT_OF_RANGE'.
enum
{
  etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__POSITIVE_OUT_OF_RANGE = 160
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__UNAVAILABLE = 161
};

/// Struct defined in msg/LongitudinalAccelerationValue in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// LongitudinalAccelerationValue::= INTEGER {
  ///     negativeOutOfRange (-160),
  ///     positiveOutOfRange (160),
  ///     unavailable        (161)
  /// } (-160 .. 161)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the vehicle acceleration at longitudinal direction in the centre of the mass of the empty vehicle.
  /// * The value shall be provided in the vehicle coordinate system as defined in ISO 8855 [21], clause 2.11.
  /// *
  /// * The value shall be set to:
  /// * - `-160` for acceleration values equal to or less than -16 m/s^2,
  /// * - `n` (`n > -160` and `n <= 0`) to indicate that the vehicle is braking with acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2
  /// * - `n` (`n > 0` and `n < 160`) to indicate that the vehicle is accelerating with acceleration equal to or less than n x 0,1 m/s^2, and greater than (n-1) x 0,1 m/s^2,
  /// * - `160` for acceleration values greater than 15,9 m/s^2,
  /// * - `161` when the data is unavailable.
  /// *
  /// * This acceleration is along the tangent plane of the road surface and does not include gravity components.
  /// * @note: this DF is kept for backwards compatibility reasons only. It is recommended to use @ref AccelerationValue instead.
  /// *
  /// * @note: The empty load vehicle is defined in ISO 1176 [8], clause 4.6.
  /// * @unit: 0,1 m/s^2
  /// * @category: Vehicle information
  /// * @revision: description revised in V2.1.1 (the meaning of 160 has changed slightly). T
  int16_t value;
} etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue.
typedef struct etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__Sequence
{
  etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__LongitudinalAccelerationValue__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__LONGITUDINAL_ACCELERATION_VALUE__STRUCT_H_
