﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/MitigationPerTechnologyClass.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/mitigation_per_technology_class.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__MITIGATION_PER_TECHNOLOGY_CLASS__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__MITIGATION_PER_TECHNOLOGY_CLASS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'LOW_DUTY_CYCLE_MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__LOW_DUTY_CYCLE_MIN = 0
};

/// Constant 'LOW_DUTY_CYCLE_MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__LOW_DUTY_CYCLE_MAX = 10000
};

/// Constant 'POWER_REDUCTION_MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__POWER_REDUCTION_MIN = 0
};

/// Constant 'POWER_REDUCTION_MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__POWER_REDUCTION_MAX = 30
};

/// Constant 'DMC_TOFF_LIMIT_MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__DMC_TOFF_LIMIT_MIN = 0
};

/// Constant 'DMC_TOFF_LIMIT_MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__DMC_TOFF_LIMIT_MAX = 1200
};

/// Constant 'DMC_TON_LIMIT_MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__DMC_TON_LIMIT_MIN = 0
};

/// Constant 'DMC_TON_LIMIT_MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__DMC_TON_LIMIT_MAX = 20
};

// Include directives for member types
// Member 'access_technology_class'
#include "etsi_its_vam_ts_msgs/msg/detail/access_technology_class__struct.h"

/// Struct defined in msg/MitigationPerTechnologyClass in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// MitigationPerTechnologyClass ::= SEQUENCE {
  ///    accessTechnologyClass    AccessTechnologyClass,
  ///    lowDutyCycle             INTEGER (0 .. 10000) OPTIONAL,
  ///    powerReduction           INTEGER (0 .. 30) OPTIONAL,
  ///    dmcToffLimit             INTEGER (0 .. 1200) OPTIONAL,
  ///    dmcTonLimit              INTEGER (0 .. 20) OPTIONAL,
  ///    ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF represents a set of mitigation parameters for a specific technology, as specified in ETSI TS 103 724 [24], clause 7.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field accessTechnologyClass:  channel access technology to which this mitigation is intended to be applied.
  /// *
  /// * @field lowDutyCycle: duty cycle limit.
  /// * @unit: 0,01 % steps
  /// *
  /// * @field powerReduction: the delta value of power to be reduced.
  /// * @unit: dB
  /// *
  /// * @field dmcToffLimit: idle time limit as defined in ETSI TS 103 175 [19].
  /// * @unit: ms
  /// *
  /// * @field dmcTonLimit: Transmission duration limit, as defined in ETSI EN 302 571 [20].
  /// * @unit: ms
  /// *
  /// * @note: All parameters are optional, as they may not apply to some of the technologies or
  /// * interference management zone types. Specification details are in ETSI TS 103 724 [24], clause 7.
  /// *
  /// * @category: Communication information
  /// * @revision: Created in V2.1.1
  etsi_its_vam_ts_msgs__msg__AccessTechnologyClass access_technology_class;
  uint16_t low_duty_cycle;
  bool low_duty_cycle_is_present;
  uint8_t power_reduction;
  bool power_reduction_is_present;
  uint16_t dmc_toff_limit;
  bool dmc_toff_limit_is_present;
  uint8_t dmc_ton_limit;
  bool dmc_ton_limit_is_present;
} etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass.
typedef struct etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence
{
  etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__MitigationPerTechnologyClass__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__MITIGATION_PER_TECHNOLOGY_CLASS__STRUCT_H_
