﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/TrafficDirection.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/traffic_direction.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__TRAFFIC_DIRECTION__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__TRAFFIC_DIRECTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'ALL_TRAFFIC_DIRECTIONS'.
enum
{
  etsi_its_vam_ts_msgs__msg__TrafficDirection__ALL_TRAFFIC_DIRECTIONS = 0
};

/// Constant 'UPSTREAM_TRAFFIC'.
enum
{
  etsi_its_vam_ts_msgs__msg__TrafficDirection__UPSTREAM_TRAFFIC = 1
};

/// Constant 'DOWNSTREAM_TRAFFIC'.
enum
{
  etsi_its_vam_ts_msgs__msg__TrafficDirection__DOWNSTREAM_TRAFFIC = 2
};

/// Constant 'OPPOSITE_TRAFFIC'.
enum
{
  etsi_its_vam_ts_msgs__msg__TrafficDirection__OPPOSITE_TRAFFIC = 3
};

/// Struct defined in msg/TrafficDirection in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__TrafficDirection
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// TrafficDirection ::= ENUMERATED {
  ///     allTrafficDirections (0),
  ///     upstreamTraffic      (1),
  ///     downstreamTraffic    (2),
  ///     oppositeTraffic      (3)
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE indicates a traffic direction that is relevant to information indicated in a message.
  /// *
  /// * The value shall be set to:
  /// * - 0 `allTrafficDirections` - for all traffic directions,
  /// * - 1 `upstreamTraffic`      - for upstream traffic,
  /// * - 2 `downstreamTraffic`    - for downstream traffic,
  /// * - 3 `oppositeTraffic`      - for traffic in the opposite direction.
  /// *
  /// * The terms `upstream`, `downstream` and `oppositeTraffic` are relative to the event position.
  /// *
  /// * @note: Upstream traffic corresponds to the incoming traffic towards the event position,
  /// * and downstream traffic to the departing traffic away from the event position.
  /// *
  /// * @category: GeoReference information
  /// * @revision: Created in V2.1.1 from RelevanceTrafficDirection
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__TrafficDirection;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__TrafficDirection.
typedef struct etsi_its_vam_ts_msgs__msg__TrafficDirection__Sequence
{
  etsi_its_vam_ts_msgs__msg__TrafficDirection * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__TrafficDirection__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__TRAFFIC_DIRECTION__STRUCT_H_
