﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/TurningRadius.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/turning_radius.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__TURNING_RADIUS__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__TURNING_RADIUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__TurningRadius__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__TurningRadius__MAX = 255
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_vam_ts_msgs__msg__TurningRadius__OUT_OF_RANGE = 254
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__TurningRadius__UNAVAILABLE = 255
};

/// Struct defined in msg/TurningRadius in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__TurningRadius
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// TurningRadius ::= INTEGER {
  ///     outOfRange  (254),
  ///     unavailable (255)
  /// } (1..255)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the smallest circular turn (i.e. U-turn) that the vehicle is capable of making.
  /// *
  /// * The value shall be set to:
  /// * - `n` (`n > 0` and `n < 254`) to indicate the applicable value is equal to or less than n x 0,4 metre, and greater than (n-1) x 0,4 metre,
  /// * - `254` to indicate that the turning radius is  greater than 253 x 0,4 metre = 101.2 metres,
  /// * - `255` to indicate that the information is unavailable.
  /// *
  /// * For vehicle with tracker, the turning radius applies to the vehicle only.
  /// *
  /// * @category: Vehicle information
  /// * @unit 0,4 metre
  /// * @revision: Description revised V2.1.1 (the meaning of 254 has changed slightly)
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__TurningRadius;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__TurningRadius.
typedef struct etsi_its_vam_ts_msgs__msg__TurningRadius__Sequence
{
  etsi_its_vam_ts_msgs__msg__TurningRadius * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__TurningRadius__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__TURNING_RADIUS__STRUCT_H_
