﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VruClusterOperationContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vru_cluster_operation_container.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_OPERATION_CONTAINER__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_OPERATION_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'cluster_join_info'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_join_info__struct.h"
// Member 'cluster_leave_info'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_leave_info__struct.h"
// Member 'cluster_breakup_info'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_breakup_info__struct.h"
// Member 'cluster_id_change_time_info'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_quarter_second__struct.h"

/// Struct defined in msg/VruClusterOperationContainer in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  ///     VruClusterOperationContainer ::= SEQUENCE {
  ///         clusterJoinInfo         ClusterJoinInfo OPTIONAL,
  ///         clusterLeaveInfo        ClusterLeaveInfo OPTIONAL,
  ///         clusterBreakupInfo      ClusterBreakupInfo OPTIONAL,
  ///         clusterIdChangeTimeInfo DeltaTimeQuarterSecond OPTIONAL,
  ///         ...
  ///     }
  /// ------------------------------------------------------------------------------
  /// *
  /// * @details VruClusterOperationContainer
  /// * The VRU Cluster Operation container of the VAM provides information relevant to change of cluster state and composition.
  /// * It is mandatory if the VAM is transmitted by a VRU joining, leaving or breaking up a cluster.
  /// * It includes the following components (setting indications are specified in clause 7.3.5 of TS 103 300-3).
  /// * At least one of the fields below shall be present if the container is present in the VAM:
  /// *
  /// * @field clusterJoinInfo: indicates the intent of an individual VAM transmitter to join a cluster.
  /// * @field clusterLeaveInfo : indicates that an individual VAM transmitter has recently left the VRU cluster.
  /// * @field clusterBreakupInfo: indicates the intent of a cluster VAM transmitter to stop sending cluster VAMs.
  /// * @field clusterIdChangeTimeInfo: indicates the intent of a cluster VAM transmitter to change cluster ID.
  /// *
  /// * @category: VRU information
  /// * @revision: V2.2.1
  etsi_its_vam_ts_msgs__msg__ClusterJoinInfo cluster_join_info;
  bool cluster_join_info_is_present;
  etsi_its_vam_ts_msgs__msg__ClusterLeaveInfo cluster_leave_info;
  bool cluster_leave_info_is_present;
  etsi_its_vam_ts_msgs__msg__ClusterBreakupInfo cluster_breakup_info;
  bool cluster_breakup_info_is_present;
  etsi_its_vam_ts_msgs__msg__DeltaTimeQuarterSecond cluster_id_change_time_info;
  bool cluster_id_change_time_info_is_present;
} etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer.
typedef struct etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence
{
  etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_OPERATION_CONTAINER__STRUCT_H_
