﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VruLowFrequencyContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_vam_ts_msgs/msg/vru_low_frequency_container.h"


#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_LOW_FREQUENCY_CONTAINER__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_LOW_FREQUENCY_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'profile_and_subprofile'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_profile_and_subprofile__struct.h"
// Member 'size_class'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_size_class__struct.h"
// Member 'exterior_lights'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_exterior_lights__struct.h"

/// Struct defined in msg/VruLowFrequencyContainer in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  ///     VruLowFrequencyContainer ::= SEQUENCE {
  ///         profileAndSubprofile     VruProfileAndSubprofile,
  ///         sizeClass                VruSizeClass OPTIONAL,
  ///   exteriorLights           VruExteriorLights OPTIONAL,
  ///        ...
  ///     }
  /// ------------------------------------------------------------------------------
  /// *
  /// * @details VruLowFrequencyContainer
  /// * The VRU LF container of the VAM contains potentially slow-changing information of the VRU ITS-S.
  /// * It is mandatory with higher periodicity as specified in clause 6.2 or when VRU cluster operation container is present.
  /// * It includes the following components (setting indications are specified in clause 7.3.4 of TS 103 300-3):
  /// *
  /// * @field profileAndSubprofile: profile of the ITS-S that originates the VAM, including sub-profile information.
  /// * @field sizeClass: information about the size of the VRU.
  /// * @field exteriorLights: status of the most important exterior lights switches of the VRU ITS-S that originates the VAM.
  /// *        _(conditional mandatory as specified in clause 7.3.4 of TS 103 300-3)_
  /// *
  /// * @category: VRU information
  /// * @revision: V2.2.1
  etsi_its_vam_ts_msgs__msg__VruProfileAndSubprofile profile_and_subprofile;
  etsi_its_vam_ts_msgs__msg__VruSizeClass size_class;
  bool size_class_is_present;
  etsi_its_vam_ts_msgs__msg__VruExteriorLights exterior_lights;
  bool exterior_lights_is_present;
} etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer.
typedef struct etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer__Sequence
{
  etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_LOW_FREQUENCY_CONTAINER__STRUCT_H_
